﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Chess
{
    public class Bishop : Piece
    {
        public override IEnumerable<BoardCoordinate> GetMovesFrom(BoardCoordinate bc, int boardSize)
        {
            List<BoardCoordinate> moves = new List<BoardCoordinate>();
            
            for(int index = 1; index <= boardSize; index++)
            {
                moves.Add(new BoardCoordinate(bc.X + index, bc.Y + index));
                moves.Add(new BoardCoordinate(bc.X - index, bc.Y - index));
                moves.Add(new BoardCoordinate(bc.X + index, bc.Y - index));
                moves.Add(new BoardCoordinate(bc.X - index, bc.Y + index));
            }

            moves.RemoveAll(m => !m.IsValidCoordinateForBoardSize(boardSize));

            return moves;
        }
    }
}
